<?php

namespace Taxus;

use http\Exception\RuntimeException;

class Privilege
{
    public ? bool $granted = false;

    public function __construct(
        public string $name,
        public string $description = "",
        public mixed /* Callable */ $function = null,
        public mixed /*? Callable*/ $success = null,
        public mixed /*? Callable*/ $error = null,
        public ? array $testableArguments = null,
    )
    {
        foreach(array_filter([ 'function' => $function, 'success' => $success, 'error' => $error ]) as $item) {
            if ( ! is_callable($item) ) {
                throw new RuntimeException("Your {$item} property must be Callable");
            }
        }
    }
}
